// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package implments

import (
	"LAPP_GAAS_GFrame_BACKEND/grmi"
	meta "LAPP_GAAS_GFrame_BACKEND/meta/base"
	model "LAPP_GAAS_GFrame_BACKEND/models/base"
	"github.com/go-xorm/xorm"
	"xorm.io/core"
)

/******************************************************************************
*
* @Struct Name              : AttributeValstDAOImplement
*-----------------------------------------------------------------------------
*
* @Description              : AttributeValst的数据访问对象实现
*
* @Author                   : 代码生成器创建
*
* @Date                     : 2021-03-24 09:53:49
*
******************************************************************************/
type AttributeValstDAOImplement struct {
	session *xorm.Session
	plantNr int
	userid  string
}

/******************************************************************************
 *
 * @Function Name            : NewAttributeValstDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : 创建一个AttributeValstDAOImplement实例
 *
 * @Function Parameters      : xorm会话
 *
 * @Function Parameters      : 基本主键
 *
 * @Return Value             : AttributeValstDAOImplement实例
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-03-24 09:53:49
 *
 ******************************************************************************/
func NewAttributeValstDAOImplement(session *xorm.Session, plantNr int, userid string) *AttributeValstDAOImplement {
	return &AttributeValstDAOImplement{session, plantNr, userid}
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/base/AttributeValstDAO.InsertOne
 *
 ******************************************************************************/
func (impl *AttributeValstDAOImplement) InsertOne(entity *model.AttributeValst) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(meta.AttributeValst.TableName).Insert(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/base/AttributeValstDAO.DeleteOne
 *
 ******************************************************************************/
func (impl *AttributeValstDAOImplement) DeleteOne(attrCode int, pos int) error {
	_, err := impl.session.Table(meta.AttributeValst.TableName).ID(core.PK{impl.plantNr, attrCode, pos}).Delete(meta.AttributeValst.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}

	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/base/AttributeValstDAO.SelectOne
 *
 ******************************************************************************/
func (impl *AttributeValstDAOImplement) SelectOne(attrCode int, pos int) (*model.AttributeValst, error) {
	var data model.AttributeValst
	ok, err := impl.session.Table(meta.AttributeValst.TableName).ID(core.PK{impl.plantNr, attrCode, pos}).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/base/AttributeValstDAO.UpdateOne
 *
 ******************************************************************************/
func (impl *AttributeValstDAOImplement) UpdateOne(entity *model.AttributeValst) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(meta.AttributeValst.TableName).Cols(meta.AttributeValst.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/base/AttributeValstDAO.Insert
 *
 ******************************************************************************/
func (impl *AttributeValstDAOImplement) Insert(entities *[]model.AttributeValst) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
	}
	_, err := impl.session.Table(meta.AttributeValst.TableName).Insert(entities)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/base/AttributeValstDAO.Delete
 *
 ******************************************************************************/
func (impl *AttributeValstDAOImplement) Delete(entities *[]model.AttributeValst) error {
	for _, entity := range *entities {
		entity.PlantNr = impl.plantNr
		_, err := impl.session.Table(meta.AttributeValst.TableName).ID(entity.GetKey()).Delete(meta.AttributeValst.Indicator)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/base/AttributeValstDAO.DeleteWhere
 *
 ******************************************************************************/
func (impl *AttributeValstDAOImplement) DeleteWhere(predicates []grmi.Predicate) error {

	parameters := []interface{}{impl.plantNr}
	where := "PlantNr = ?"

	session := impl.session.Table(meta.AttributeValst.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	_, err := session.Delete(meta.AttributeValst.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/base/AttributeValstDAO.Select
 *
 ******************************************************************************/
func (impl *AttributeValstDAOImplement) Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.AttributeValst, error) {

	parameters := []interface{}{impl.plantNr}
	where := "PlantNr = ?"

	session := impl.session.Table(meta.AttributeValst.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	session = session.OrderBy("PlantNr")
	if orderByFields != nil {
		for _, field := range orderByFields {
			session = session.OrderBy(field.ColumnName)
		}
	}

	data := make([]model.AttributeValst, 0, 10)
	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/base/AttributeValstDAO.SelectAndPaging
 *
 ******************************************************************************/
func (impl *AttributeValstDAOImplement) SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error) {

	parameters := []interface{}{impl.plantNr}
	where := "PlantNr = ?"

	session := impl.session.Table(meta.AttributeValst.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	count, err := session.Count(meta.AttributeValst.Indicator)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}

	orderBy := " order by PlantNr"
	if orderByFields != nil {
		for _, field := range orderByFields {
			orderBy += ", " + field.ColumnName
		}
	}
	parameters = append(parameters, paging.Offset(), paging.Size)
	data := make([]model.AttributeValst, 0, 10)
	if where != "" {
		where = " where " + where
	}
	err = impl.session.Table(meta.AttributeValst.TableName).SQL("select * from "+meta.AttributeValst.TableName+where+orderBy+" offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	return grmi.PagingResult{Records: data, Count: count, PageNumber: paging.Number, PageSize: paging.Size}, nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/base/AttributeValstDAO.Update
 *
 ******************************************************************************/
func (impl *AttributeValstDAOImplement) Update(entities *[]model.AttributeValst) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
		_, err := impl.session.Table(meta.AttributeValst.TableName).Cols(meta.AttributeValst.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/base/AttributeValstDAO.UpdateWhere
 *
 ******************************************************************************/
func (impl *AttributeValstDAOImplement) UpdateWhere(predicates []grmi.Predicate, entity *model.AttributeValst, columns ...string) error {

	parameters := []interface{}{impl.plantNr}
	where := "PlantNr = ?"

	session := impl.session.Table(meta.AttributeValst.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	columns = append(columns, meta.AttributeValst_LastUser.ColumnName)
	entity.LastUser = impl.userid
	_, err := impl.session.Table(meta.AttributeValst.TableName).Cols(columns...).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}
