// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package implments

import (
	"LAPP_GAAS_GFrame_BACKEND/grmi"
	meta "LAPP_GAAS_GFrame_BACKEND/meta/base"
	model "LAPP_GAAS_GFrame_BACKEND/models/base"
	"github.com/go-xorm/xorm"
	"xorm.io/core"
)

/******************************************************************************
*
* @Struct Name              : WorkLineSpecialTimeDAOImplement
*-----------------------------------------------------------------------------
*
* @Description              : WorkLineSpecialTime的数据访问对象实现
*
* @Author                   : 代码生成器创建
*
* @Date                     : 2021-03-24 09:53:49
*
******************************************************************************/
type WorkLineSpecialTimeDAOImplement struct {
	session *xorm.Session
	plantNr int
	userid  string
}

/******************************************************************************
 *
 * @Function Name            : NewWorkLineSpecialTimeDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : 创建一个WorkLineSpecialTimeDAOImplement实例
 *
 * @Function Parameters      : xorm会话
 *
 * @Function Parameters      : 基本主键
 *
 * @Return Value             : WorkLineSpecialTimeDAOImplement实例
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-03-24 09:53:49
 *
 ******************************************************************************/
func NewWorkLineSpecialTimeDAOImplement(session *xorm.Session, plantNr int, userid string) *WorkLineSpecialTimeDAOImplement {
	return &WorkLineSpecialTimeDAOImplement{session, plantNr, userid}
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/base/WorkLineSpecialTimeDAO.InsertOne
 *
 ******************************************************************************/
func (impl *WorkLineSpecialTimeDAOImplement) InsertOne(entity *model.WorkLineSpecialTime) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(meta.WorkLineSpecialTime.TableName).Insert(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/base/WorkLineSpecialTimeDAO.DeleteOne
 *
 ******************************************************************************/
func (impl *WorkLineSpecialTimeDAOImplement) DeleteOne(workLineid string, begTime grmi.DateTime) error {
	_, err := impl.session.Table(meta.WorkLineSpecialTime.TableName).ID(core.PK{impl.plantNr, workLineid, begTime.ToString()}).Delete(meta.WorkLineSpecialTime.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}

	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/base/WorkLineSpecialTimeDAO.SelectOne
 *
 ******************************************************************************/
func (impl *WorkLineSpecialTimeDAOImplement) SelectOne(workLineid string, begTime grmi.DateTime) (*model.WorkLineSpecialTime, error) {
	var data model.WorkLineSpecialTime
	ok, err := impl.session.Table(meta.WorkLineSpecialTime.TableName).ID(core.PK{impl.plantNr, workLineid, begTime.ToString()}).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/base/WorkLineSpecialTimeDAO.UpdateOne
 *
 ******************************************************************************/
func (impl *WorkLineSpecialTimeDAOImplement) UpdateOne(entity *model.WorkLineSpecialTime) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(meta.WorkLineSpecialTime.TableName).Cols(meta.WorkLineSpecialTime.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/base/WorkLineSpecialTimeDAO.Insert
 *
 ******************************************************************************/
func (impl *WorkLineSpecialTimeDAOImplement) Insert(entities *[]model.WorkLineSpecialTime) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
	}
	_, err := impl.session.Table(meta.WorkLineSpecialTime.TableName).Insert(entities)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/base/WorkLineSpecialTimeDAO.Delete
 *
 ******************************************************************************/
func (impl *WorkLineSpecialTimeDAOImplement) Delete(entities *[]model.WorkLineSpecialTime) error {
	for _, entity := range *entities {
		entity.PlantNr = impl.plantNr
		_, err := impl.session.Table(meta.WorkLineSpecialTime.TableName).ID(entity.GetKey()).Delete(meta.WorkLineSpecialTime.Indicator)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/base/WorkLineSpecialTimeDAO.DeleteWhere
 *
 ******************************************************************************/
func (impl *WorkLineSpecialTimeDAOImplement) DeleteWhere(predicates []grmi.Predicate) error {

	parameters := []interface{}{impl.plantNr}
	where := "PlantNr = ?"

	session := impl.session.Table(meta.WorkLineSpecialTime.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	_, err := session.Delete(meta.WorkLineSpecialTime.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/base/WorkLineSpecialTimeDAO.Select
 *
 ******************************************************************************/
func (impl *WorkLineSpecialTimeDAOImplement) Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.WorkLineSpecialTime, error) {

	parameters := []interface{}{impl.plantNr}
	where := "PlantNr = ?"

	session := impl.session.Table(meta.WorkLineSpecialTime.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	session = session.OrderBy("PlantNr")
	if orderByFields != nil {
		for _, field := range orderByFields {
			session = session.OrderBy(field.ColumnName)
		}
	}

	data := make([]model.WorkLineSpecialTime, 0, 10)
	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/base/WorkLineSpecialTimeDAO.SelectAndPaging
 *
 ******************************************************************************/
func (impl *WorkLineSpecialTimeDAOImplement) SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error) {

	parameters := []interface{}{impl.plantNr}
	where := "PlantNr = ?"

	session := impl.session.Table(meta.WorkLineSpecialTime.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	count, err := session.Count(meta.WorkLineSpecialTime.Indicator)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}

	orderBy := " order by PlantNr"
	if orderByFields != nil {
		for _, field := range orderByFields {
			orderBy += ", " + field.ColumnName
		}
	}
	parameters = append(parameters, paging.Offset(), paging.Size)
	data := make([]model.WorkLineSpecialTime, 0, 10)
	if where != "" {
		where = " where " + where
	}
	err = impl.session.Table(meta.WorkLineSpecialTime.TableName).SQL("select * from "+meta.WorkLineSpecialTime.TableName+where+orderBy+" offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	return grmi.PagingResult{Records: data, Count: count, PageNumber: paging.Number, PageSize: paging.Size}, nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/base/WorkLineSpecialTimeDAO.Update
 *
 ******************************************************************************/
func (impl *WorkLineSpecialTimeDAOImplement) Update(entities *[]model.WorkLineSpecialTime) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
		_, err := impl.session.Table(meta.WorkLineSpecialTime.TableName).Cols(meta.WorkLineSpecialTime.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/base/WorkLineSpecialTimeDAO.UpdateWhere
 *
 ******************************************************************************/
func (impl *WorkLineSpecialTimeDAOImplement) UpdateWhere(predicates []grmi.Predicate, entity *model.WorkLineSpecialTime, columns ...string) error {

	parameters := []interface{}{impl.plantNr}
	where := "PlantNr = ?"

	session := impl.session.Table(meta.WorkLineSpecialTime.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	columns = append(columns, meta.WorkLineSpecialTime_LastUser.ColumnName)
	entity.LastUser = impl.userid
	_, err := impl.session.Table(meta.WorkLineSpecialTime.TableName).Cols(columns...).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}
