// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package implments

import (
	"LAPP_GAAS_GFrame_BACKEND/grmi"
	meta "LAPP_GAAS_GFrame_BACKEND/meta/ods"
	model "LAPP_GAAS_GFrame_BACKEND/models/ods"
	"github.com/go-xorm/xorm"
	"xorm.io/core"
)

/******************************************************************************
*
* @Struct Name              : OdsStepLstDAOImplement
*-----------------------------------------------------------------------------
*
* @Description              : OdsStepLst的数据访问对象实现
*
* @Author                   : 代码生成器创建
*
* @Date                     : 2021-03-24 09:53:49
*
******************************************************************************/
type OdsStepLstDAOImplement struct {
	session *xorm.Session
	plantNr int
	userid  string
}

/******************************************************************************
 *
 * @Function Name            : NewOdsStepLstDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : 创建一个OdsStepLstDAOImplement实例
 *
 * @Function Parameters      : xorm会话
 *
 * @Function Parameters      : 基本主键
 *
 * @Return Value             : OdsStepLstDAOImplement实例
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-03-24 09:53:49
 *
 ******************************************************************************/
func NewOdsStepLstDAOImplement(session *xorm.Session, plantNr int, userid string) *OdsStepLstDAOImplement {
	return &OdsStepLstDAOImplement{session, plantNr, userid}
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/ods/OdsStepLstDAO.InsertOne
 *
 ******************************************************************************/
func (impl *OdsStepLstDAOImplement) InsertOne(entity *model.OdsStepLst) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(meta.OdsStepLst.TableName).Insert(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/ods/OdsStepLstDAO.DeleteOne
 *
 ******************************************************************************/
func (impl *OdsStepLstDAOImplement) DeleteOne(odsId string, pos int) error {
	_, err := impl.session.Table(meta.OdsStepLst.TableName).ID(core.PK{impl.plantNr, odsId, pos}).Delete(meta.OdsStepLst.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}

	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/ods/OdsStepLstDAO.SelectOne
 *
 ******************************************************************************/
func (impl *OdsStepLstDAOImplement) SelectOne(odsId string, pos int) (*model.OdsStepLst, error) {
	var data model.OdsStepLst
	ok, err := impl.session.Table(meta.OdsStepLst.TableName).ID(core.PK{impl.plantNr, odsId, pos}).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/ods/OdsStepLstDAO.UpdateOne
 *
 ******************************************************************************/
func (impl *OdsStepLstDAOImplement) UpdateOne(entity *model.OdsStepLst) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(meta.OdsStepLst.TableName).Cols(meta.OdsStepLst.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/ods/OdsStepLstDAO.Insert
 *
 ******************************************************************************/
func (impl *OdsStepLstDAOImplement) Insert(entities *[]model.OdsStepLst) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
	}
	_, err := impl.session.Table(meta.OdsStepLst.TableName).Insert(entities)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/ods/OdsStepLstDAO.Delete
 *
 ******************************************************************************/
func (impl *OdsStepLstDAOImplement) Delete(entities *[]model.OdsStepLst) error {
	for _, entity := range *entities {
		entity.PlantNr = impl.plantNr
		_, err := impl.session.Table(meta.OdsStepLst.TableName).ID(entity.GetKey()).Delete(meta.OdsStepLst.Indicator)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/ods/OdsStepLstDAO.DeleteWhere
 *
 ******************************************************************************/
func (impl *OdsStepLstDAOImplement) DeleteWhere(predicates []grmi.Predicate) error {

	parameters := []interface{}{impl.plantNr}
	where := "PlantNr = ?"

	session := impl.session.Table(meta.OdsStepLst.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	_, err := session.Delete(meta.OdsStepLst.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/ods/OdsStepLstDAO.Select
 *
 ******************************************************************************/
func (impl *OdsStepLstDAOImplement) Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.OdsStepLst, error) {

	parameters := []interface{}{impl.plantNr}
	where := "PlantNr = ?"

	session := impl.session.Table(meta.OdsStepLst.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	session = session.OrderBy("PlantNr")
	if orderByFields != nil {
		for _, field := range orderByFields {
			session = session.OrderBy(field.ColumnName)
		}
	}

	data := make([]model.OdsStepLst, 0, 10)
	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/ods/OdsStepLstDAO.SelectAndPaging
 *
 ******************************************************************************/
func (impl *OdsStepLstDAOImplement) SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error) {

	parameters := []interface{}{impl.plantNr}
	where := "PlantNr = ?"

	session := impl.session.Table(meta.OdsStepLst.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	count, err := session.Count(meta.OdsStepLst.Indicator)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}

	orderBy := " order by PlantNr"
	if orderByFields != nil {
		for _, field := range orderByFields {
			orderBy += ", " + field.ColumnName
		}
	}
	parameters = append(parameters, paging.Offset(), paging.Size)
	data := make([]model.OdsStepLst, 0, 10)
	if where != "" {
		where = " where " + where
	}
	err = impl.session.Table(meta.OdsStepLst.TableName).SQL("select * from "+meta.OdsStepLst.TableName+where+orderBy+" offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	return grmi.PagingResult{Records: data, Count: count, PageNumber: paging.Number, PageSize: paging.Size}, nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/ods/OdsStepLstDAO.Update
 *
 ******************************************************************************/
func (impl *OdsStepLstDAOImplement) Update(entities *[]model.OdsStepLst) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
		_, err := impl.session.Table(meta.OdsStepLst.TableName).Cols(meta.OdsStepLst.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/ods/OdsStepLstDAO.UpdateWhere
 *
 ******************************************************************************/
func (impl *OdsStepLstDAOImplement) UpdateWhere(predicates []grmi.Predicate, entity *model.OdsStepLst, columns ...string) error {

	parameters := []interface{}{impl.plantNr}
	where := "PlantNr = ?"

	session := impl.session.Table(meta.OdsStepLst.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	columns = append(columns, meta.OdsStepLst_LastUser.ColumnName)
	entity.LastUser = impl.userid
	_, err := impl.session.Table(meta.OdsStepLst.TableName).Cols(columns...).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}
