// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package implments

import (
	"LAPP_GAAS_GFrame_BACKEND/grmi"
	meta "LAPP_GAAS_GFrame_BACKEND/meta/pm"
	model "LAPP_GAAS_GFrame_BACKEND/models/pm"
	"github.com/go-xorm/xorm"
	"xorm.io/core"
)

/******************************************************************************
 *
 * @Struct Name              : UserServiceLstDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : UserServiceLst的数据访问对象实现
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-03-18 22:50:49
 *
 ******************************************************************************/
type UserServiceLstDAOImplement struct {
	session *xorm.Session
	plantNr int
	userid  string
}

/******************************************************************************
 *
 * @Function Name            : NewUserServiceLstDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : 创建一个UserServiceLstDAOImplement实例
 *
 * @Function Parameters      : xorm会话
 *
 * @Function Parameters      : 基本主键
 *
 * @Return Value             : UserServiceLstDAOImplement实例
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-03-18 22:50:49
 *
 ******************************************************************************/
func NewUserServiceLstDAOImplement(session *xorm.Session, plantNr int, userid string) *UserServiceLstDAOImplement {
	return &UserServiceLstDAOImplement{session, plantNr, userid}
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/pm/UserServiceLstDAO.InsertOne
 *
 ******************************************************************************/
func (impl *UserServiceLstDAOImplement) InsertOne(entity *model.UserServiceLst) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(meta.UserServiceLst.TableName).Insert(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/pm/UserServiceLstDAO.DeleteOne
 *
 ******************************************************************************/
func (impl *UserServiceLstDAOImplement) DeleteOne(userId string, mainServiceId string) error {
	_, err := impl.session.Table(meta.UserServiceLst.TableName).ID(core.PK{impl.plantNr, userId, mainServiceId}).Delete(meta.UserServiceLst.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}

	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/pm/UserServiceLstDAO.SelectOne
 *
 ******************************************************************************/
func (impl *UserServiceLstDAOImplement) SelectOne(userId string, mainServiceId string) (*model.UserServiceLst, error) {
	var data model.UserServiceLst
	ok, err := impl.session.Table(meta.UserServiceLst.TableName).ID(core.PK{impl.plantNr, userId, mainServiceId}).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/pm/UserServiceLstDAO.UpdateOne
 *
 ******************************************************************************/
func (impl *UserServiceLstDAOImplement) UpdateOne(entity *model.UserServiceLst) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(meta.UserServiceLst.TableName).Cols(meta.UserServiceLst.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/pm/UserServiceLstDAO.Insert
 *
 ******************************************************************************/
func (impl *UserServiceLstDAOImplement) Insert(entities *[]model.UserServiceLst) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
	}
	_, err := impl.session.Table(meta.UserServiceLst.TableName).Insert(entities)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/pm/UserServiceLstDAO.Delete
 *
 ******************************************************************************/
func (impl *UserServiceLstDAOImplement) Delete(entities *[]model.UserServiceLst) error {
	for _, entity := range *entities {
		entity.PlantNr = impl.plantNr
		_, err := impl.session.Table(meta.UserServiceLst.TableName).ID(entity.GetKey()).Delete(meta.UserServiceLst.Indicator)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/pm/UserServiceLstDAO.DeleteWhere
 *
 ******************************************************************************/
func (impl *UserServiceLstDAOImplement) DeleteWhere(predicates []grmi.Predicate) error {

	parameters := []interface{}{impl.plantNr}
	where := "PlantNr = ?"

	session := impl.session.Table(meta.UserServiceLst.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	_, err := session.Delete(meta.UserServiceLst.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/pm/UserServiceLstDAO.Select
 *
 ******************************************************************************/
func (impl *UserServiceLstDAOImplement) Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.UserServiceLst, error) {

	parameters := []interface{}{impl.plantNr}
	where := "PlantNr = ?"

	session := impl.session.Table(meta.UserServiceLst.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	session = session.OrderBy("PlantNr")
	if orderByFields != nil {
		for _, field := range orderByFields {
			session = session.OrderBy(field.ColumnName)
		}
	}

	data := make([]model.UserServiceLst, 0, 10)
	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/pm/UserServiceLstDAO.SelectAndPaging
 *
 ******************************************************************************/
func (impl *UserServiceLstDAOImplement) SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error) {

	parameters := []interface{}{impl.plantNr}
	where := "PlantNr = ?"

	session := impl.session.Table(meta.UserServiceLst.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	count, err := session.Count(meta.UserServiceLst.Indicator)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}

	orderBy := " order by PlantNr"
	if orderByFields != nil {
		for _, field := range orderByFields {
			orderBy += ", " + field.ColumnName
		}
	}
	parameters = append(parameters, paging.Offset(), paging.Size)
	data := make([]model.UserServiceLst, 0, 10)
	if where != "" {
		where = " where " + where
	}
	err = impl.session.Table(meta.UserServiceLst.TableName).SQL("select * from "+meta.UserServiceLst.TableName+where+orderBy+" offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	return grmi.PagingResult{Records: data, Count: count, PageNumber: paging.Number, PageSize: paging.Size}, nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/pm/UserServiceLstDAO.Update
 *
 ******************************************************************************/
func (impl *UserServiceLstDAOImplement) Update(entities *[]model.UserServiceLst) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
		_, err := impl.session.Table(meta.UserServiceLst.TableName).Cols(meta.UserServiceLst.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/pm/UserServiceLstDAO.UpdateWhere
 *
 ******************************************************************************/
func (impl *UserServiceLstDAOImplement) UpdateWhere(predicates []grmi.Predicate, entity *model.UserServiceLst, columns ...string) error {

	parameters := []interface{}{impl.plantNr}
	where := "PlantNr = ?"

	session := impl.session.Table(meta.UserServiceLst.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	columns = append(columns, meta.UserServiceLst_LastUser.ColumnName)
	entity.LastUser = impl.userid
	_, err := impl.session.Table(meta.UserServiceLst.TableName).Cols(columns...).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}
