// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package implments

import (
	"LAPP_GAAS_GFrame_BACKEND/grmi"
	meta "LAPP_GAAS_GFrame_BACKEND/meta/pm"
	model "LAPP_GAAS_GFrame_BACKEND/models/pm"
	"github.com/go-xorm/xorm"
	"xorm.io/core"
)

/******************************************************************************
 *
 * @Struct Name              : WorkOrderAttrLstDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : WorkOrderAttrLst的数据访问对象实现
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-04-13 11:00:13
 *
 ******************************************************************************/
type WorkOrderAttrLstDAOImplement struct {
	session *xorm.Session
	plantNr int
	userid  string
}

/******************************************************************************
 *
 * @Function Name            : NewWorkOrderAttrLstDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : 创建一个WorkOrderAttrLstDAOImplement实例
 *
 * @Function Parameters      : xorm会话
 *
 * @Function Parameters      : 基本主键
 *
 * @Return Value             : WorkOrderAttrLstDAOImplement实例
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-04-13 11:00:13
 *
 ******************************************************************************/
func NewWorkOrderAttrLstDAOImplement(session *xorm.Session, plantNr int, userid string) *WorkOrderAttrLstDAOImplement {
	return &WorkOrderAttrLstDAOImplement{session, plantNr, userid}
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/pm/WorkOrderAttrLstDAO.InsertOne
 *
 ******************************************************************************/
func (impl *WorkOrderAttrLstDAOImplement) InsertOne(entity *model.WorkOrderAttrLst) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(meta.WorkOrderAttrLst.TableName).Insert(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/pm/WorkOrderAttrLstDAO.DeleteOne
 *
 ******************************************************************************/
func (impl *WorkOrderAttrLstDAOImplement) DeleteOne(maintWorkOrderId string, mainServiceNr int, attrNr int) error {
	_, err := impl.session.Table(meta.WorkOrderAttrLst.TableName).ID(core.PK{impl.plantNr, maintWorkOrderId, mainServiceNr, attrNr}).Delete(meta.WorkOrderAttrLst.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}

	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/pm/WorkOrderAttrLstDAO.SelectOne
 *
 ******************************************************************************/
func (impl *WorkOrderAttrLstDAOImplement) SelectOne(maintWorkOrderId string, mainServiceNr int, attrNr int) (*model.WorkOrderAttrLst, error) {
	var data model.WorkOrderAttrLst
	ok, err := impl.session.Table(meta.WorkOrderAttrLst.TableName).ID(core.PK{impl.plantNr, maintWorkOrderId, mainServiceNr, attrNr}).Get(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	if !ok {
		return nil, nil
	}
	return &data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/pm/WorkOrderAttrLstDAO.UpdateOne
 *
 ******************************************************************************/
func (impl *WorkOrderAttrLstDAOImplement) UpdateOne(entity *model.WorkOrderAttrLst) error {
	entity.PlantNr = impl.plantNr
	entity.LastUser = impl.userid
	_, err := impl.session.Table(meta.WorkOrderAttrLst.TableName).Cols(meta.WorkOrderAttrLst.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/pm/WorkOrderAttrLstDAO.Insert
 *
 ******************************************************************************/
func (impl *WorkOrderAttrLstDAOImplement) Insert(entities *[]model.WorkOrderAttrLst) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
	}
	_, err := impl.session.Table(meta.WorkOrderAttrLst.TableName).Insert(entities)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/pm/WorkOrderAttrLstDAO.Delete
 *
 ******************************************************************************/
func (impl *WorkOrderAttrLstDAOImplement) Delete(entities *[]model.WorkOrderAttrLst) error {
	for _, entity := range *entities {
		entity.PlantNr = impl.plantNr
		_, err := impl.session.Table(meta.WorkOrderAttrLst.TableName).ID(entity.GetKey()).Delete(meta.WorkOrderAttrLst.Indicator)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/pm/WorkOrderAttrLstDAO.DeleteWhere
 *
 ******************************************************************************/
func (impl *WorkOrderAttrLstDAOImplement) DeleteWhere(predicates []grmi.Predicate) error {

	parameters := []interface{}{impl.plantNr}
	where := "PlantNr = ?"

	session := impl.session.Table(meta.WorkOrderAttrLst.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	_, err := session.Delete(meta.WorkOrderAttrLst.Indicator)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/pm/WorkOrderAttrLstDAO.Select
 *
 ******************************************************************************/
func (impl *WorkOrderAttrLstDAOImplement) Select(predicates []grmi.Predicate, orderByFields []grmi.Field) ([]model.WorkOrderAttrLst, error) {

	parameters := []interface{}{impl.plantNr}
	where := "PlantNr = ?"

	session := impl.session.Table(meta.WorkOrderAttrLst.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	session = session.OrderBy("PlantNr")
	if orderByFields != nil {
		for _, field := range orderByFields {
			session = session.OrderBy(field.ColumnName)
		}
	}

	data := make([]model.WorkOrderAttrLst, 0, 10)
	err := session.Find(&data)
	if err != nil {
		return nil, grmi.NewDataBaseError(err)
	}
	return data, nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/pm/WorkOrderAttrLstDAO.SelectAndPaging
 *
 ******************************************************************************/
func (impl *WorkOrderAttrLstDAOImplement) SelectAndPaging(paging *grmi.Paging, predicates []grmi.Predicate, orderByFields []grmi.Field) (grmi.PagingResult, error) {

	parameters := []interface{}{impl.plantNr}
	where := "PlantNr = ?"

	session := impl.session.Table(meta.WorkOrderAttrLst.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	count, err := session.Count(meta.WorkOrderAttrLst.Indicator)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}

	orderBy := " order by PlantNr"
	if orderByFields != nil {
		for _, field := range orderByFields {
			orderBy += ", " + field.ColumnName
		}
	}
	parameters = append(parameters, paging.Offset(), paging.Size)
	data := make([]model.WorkOrderAttrLst, 0, 10)
	if where != "" {
		where = " where " + where
	}
	err = impl.session.Table(meta.WorkOrderAttrLst.TableName).SQL("select * from "+meta.WorkOrderAttrLst.TableName+where+orderBy+" offset ? row fetch next ? row only", parameters...).Find(&data)
	if err != nil {
		return grmi.EmptyPagingResult, err
	}
	return grmi.PagingResult{Records: data, Count: count, PageNumber: paging.Number, PageSize: paging.Size}, nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/pm/WorkOrderAttrLstDAO.Update
 *
 ******************************************************************************/
func (impl *WorkOrderAttrLstDAOImplement) Update(entities *[]model.WorkOrderAttrLst) error {
	for i := 0; i < len(*entities); i++ {
		entity := &(*entities)[i]
		entity.PlantNr = impl.plantNr
		entity.LastUser = impl.userid
		_, err := impl.session.Table(meta.WorkOrderAttrLst.TableName).Cols(meta.WorkOrderAttrLst.UpdatingMembers...).ID(entity.GetKey()).Update(entity)
		if err != nil {
			return grmi.NewDataBaseError(err)
		}
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/dao/pm/WorkOrderAttrLstDAO.UpdateWhere
 *
 ******************************************************************************/
func (impl *WorkOrderAttrLstDAOImplement) UpdateWhere(predicates []grmi.Predicate, entity *model.WorkOrderAttrLst, columns ...string) error {

	parameters := []interface{}{impl.plantNr}
	where := "PlantNr = ?"

	session := impl.session.Table(meta.WorkOrderAttrLst.TableName)
	if predicates != nil {
		for _, predicate := range predicates {
			where += predicate.Build()
			parameters = append(parameters, predicate.Values...)
		}
		session = session.Where(where, parameters...)
	} else {
		session = session.Where(where, parameters...)
	}

	columns = append(columns, meta.WorkOrderAttrLst_LastUser.ColumnName)
	entity.LastUser = impl.userid
	_, err := impl.session.Table(meta.WorkOrderAttrLst.TableName).Cols(columns...).Update(entity)
	if err != nil {
		return grmi.NewDataBaseError(err)
	}
	return nil
}
