// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package pm

import (
	"LAPP_GAAS_GFrame_BACKEND/grmi"
	model "LAPP_GAAS_GFrame_BACKEND/models/pm"
)

/******************************************************************************
 *
 * @Description              : Service的字段元数据
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-04-13 11:00:13
 *
 ******************************************************************************/
var Service_MainServiceNr = grmi.NewField("MainServiceNr", "MainServiceNr", "mainservicenr", grmi.TypeInt)
var Service_Descr = grmi.NewField("Descr", "Descr", "descr", grmi.TypeString)
var Service_MaintType = grmi.NewField("MaintType", "MaintType", "mainttype", grmi.TypeString)
var Service_Priority = grmi.NewField("Priority", "Priority", "priority", grmi.TypeInt)
var Service_EnabledToggle = grmi.NewField("EnabledToggle", "EnabledToggle", "enabledtoggle", grmi.TypeBool)
var Service_MaintByDateToggle = grmi.NewField("MaintByDateToggle", "MaintByDateToggle", "maintbydatetoggle", grmi.TypeBool)
var Service_DueDateInterval = grmi.NewField("DueDateInterval", "DueDateInterval", "duedateinterval", grmi.TypeInt)
var Service_NodifyDays = grmi.NewField("NodifyDays", "NodifyDays", "nodifydays", grmi.TypeInt)
var Service_DueDateOn = grmi.NewField("DueDateOn", "DueDateOn", "duedateon", grmi.TypeDate)
var Service_MaintByHourToggle = grmi.NewField("MaintByHourToggle", "MaintByHourToggle", "maintbyhourtoggle", grmi.TypeBool)
var Service_DueHourInterval = grmi.NewField("DueHourInterval", "DueHourInterval", "duehourinterval", grmi.TypeInt)
var Service_NodifyHours = grmi.NewField("NodifyHours", "NodifyHours", "nodifyhours", grmi.TypeInt)
var Service_DueHourOn = grmi.NewField("DueHourOn", "DueHourOn", "duehouron", grmi.TypeDate)
var Service_MaintByMileageToggle = grmi.NewField("MaintByMileageToggle", "MaintByMileageToggle", "maintbymileagetoggle", grmi.TypeBool)
var Service_DueMileageInterval = grmi.NewField("DueMileageInterval", "DueMileageInterval", "duemileageinterval", grmi.TypeInt)
var Service_NodifyMileages = grmi.NewField("NodifyMileages", "NodifyMileages", "nodifymileages", grmi.TypeInt)
var Service_DueMileageAt = grmi.NewField("DueMileageAt", "DueMileageAt", "duemileageat", grmi.TypeInt)
var Service_NeedSchedule = grmi.NewField("NeedSchedule", "NeedSchedule", "needschedule", grmi.TypeInt)
var Service_MainTimeLen = grmi.NewField("MainTimeLen", "MainTimeLen", "maintimelen", grmi.TypeFloat64)
var Service_TimeUnit = grmi.NewField("TimeUnit", "TimeUnit", "timeunit", grmi.TypeString)
var Service_SchedType = grmi.NewField("SchedType", "SchedType", "schedtype", grmi.TypeString)
var Service_Department = grmi.NewField("Department", "Department", "department", grmi.TypeString)
var Service_LastModify = grmi.NewField("LastModify", "LastModify", "lastmodify", grmi.TypeDateTime)
var Service_LastUser = grmi.NewField("LastUser", "LastUser", "lastuser", grmi.TypeString)
var Service_CreateTime = grmi.NewField("CreateTime", "CreateTime", "createtime", grmi.TypeDateTime)

/******************************************************************************
 *
 * @Description              : Service的元数据
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-04-13 11:00:13
 *
 ******************************************************************************/
var Service = grmi.NewEntity(
	"PM_ServiceNew",
	func() interface{} { return &model.Service{} },
	map[string]grmi.Field{
		Service_MainServiceNr.Name:        Service_MainServiceNr,
		Service_Descr.Name:                Service_Descr,
		Service_MaintType.Name:            Service_MaintType,
		Service_Priority.Name:             Service_Priority,
		Service_EnabledToggle.Name:        Service_EnabledToggle,
		Service_MaintByDateToggle.Name:    Service_MaintByDateToggle,
		Service_DueDateInterval.Name:      Service_DueDateInterval,
		Service_NodifyDays.Name:           Service_NodifyDays,
		Service_DueDateOn.Name:            Service_DueDateOn,
		Service_MaintByHourToggle.Name:    Service_MaintByHourToggle,
		Service_DueHourInterval.Name:      Service_DueHourInterval,
		Service_NodifyHours.Name:          Service_NodifyHours,
		Service_DueHourOn.Name:            Service_DueHourOn,
		Service_MaintByMileageToggle.Name: Service_MaintByMileageToggle,
		Service_DueMileageInterval.Name:   Service_DueMileageInterval,
		Service_NodifyMileages.Name:       Service_NodifyMileages,
		Service_DueMileageAt.Name:         Service_DueMileageAt,
		Service_NeedSchedule.Name:         Service_NeedSchedule,
		Service_MainTimeLen.Name:          Service_MainTimeLen,
		Service_TimeUnit.Name:             Service_TimeUnit,
		Service_SchedType.Name:            Service_SchedType,
		Service_Department.Name:           Service_Department,
		Service_LastModify.Name:           Service_LastModify,
		Service_LastUser.Name:             Service_LastUser,
		Service_CreateTime.Name:           Service_CreateTime,
	},
	[]string{"PlantNr"},
	[]string{Service_Descr.ColumnName, Service_MaintType.ColumnName, Service_Priority.ColumnName, Service_EnabledToggle.ColumnName, Service_MaintByDateToggle.ColumnName, Service_DueDateInterval.ColumnName, Service_NodifyDays.ColumnName, Service_DueDateOn.ColumnName, Service_MaintByHourToggle.ColumnName, Service_DueHourInterval.ColumnName, Service_NodifyHours.ColumnName, Service_DueHourOn.ColumnName, Service_MaintByMileageToggle.ColumnName, Service_DueMileageInterval.ColumnName, Service_NodifyMileages.ColumnName, Service_DueMileageAt.ColumnName, Service_NeedSchedule.ColumnName, Service_MainTimeLen.ColumnName, Service_TimeUnit.ColumnName, Service_SchedType.ColumnName, Service_Department.ColumnName, Service_LastUser.ColumnName})
