// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package pm

import (
	"LAPP_GAAS_GFrame_BACKEND/grmi"
	model "LAPP_GAAS_GFrame_BACKEND/models/pm"
)

/******************************************************************************
 *
 * @Description              : WorkOrder的字段元数据
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-04-13 11:00:13
 *
 ******************************************************************************/
var WorkOrder_MaintWorkOrderId = grmi.NewField("MaintWorkOrderId", "MaintWorkOrderId", "maintworkorderid", grmi.TypeString)
var WorkOrder_MainServiceNr = grmi.NewField("MainServiceNr", "MainServiceNr", "mainservicenr", grmi.TypeString)
var WorkOrder_Descr = grmi.NewField("Descr", "Descr", "descr", grmi.TypeString)
var WorkOrder_Status = grmi.NewField("Status", "Status", "status", grmi.TypeInt)
var WorkOrder_Priority = grmi.NewField("Priority", "Priority", "priority", grmi.TypeInt)
var WorkOrder_AssetNr = grmi.NewField("AssetNr", "AssetNr", "assetnr", grmi.TypeInt)
var WorkOrder_PlBegDat = grmi.NewField("PlBegDat", "PlBegDat", "plbegdat", grmi.TypeDate)
var WorkOrder_PlEndDat = grmi.NewField("PlEndDat", "PlEndDat", "plenddat", grmi.TypeDate)
var WorkOrder_NeedSchedule = grmi.NewField("NeedSchedule", "NeedSchedule", "needschedule", grmi.TypeInt)
var WorkOrder_MainTimeLen = grmi.NewField("MainTimeLen", "MainTimeLen", "maintimelen", grmi.TypeFloat64)
var WorkOrder_TimeUnit = grmi.NewField("TimeUnit", "TimeUnit", "timeunit", grmi.TypeString)
var WorkOrder_SchedBegTime = grmi.NewField("SchedBegTime", "SchedBegTime", "schedbegtime", grmi.TypeDateTime)
var WorkOrder_SchedEndTime = grmi.NewField("SchedEndTime", "SchedEndTime", "schedendtime", grmi.TypeDateTime)
var WorkOrder_ActBegTime = grmi.NewField("ActBegTime", "ActBegTime", "actbegtime", grmi.TypeDateTime)
var WorkOrder_ActEndTime = grmi.NewField("ActEndTime", "ActEndTime", "actendtime", grmi.TypeDateTime)
var WorkOrder_AssignedTo = grmi.NewField("AssignedTo", "AssignedTo", "assignedto", grmi.TypeString)
var WorkOrder_Operator = grmi.NewField("Operator", "Operator", "operator", grmi.TypeInt)
var WorkOrder_Vendor = grmi.NewField("Vendor", "Vendor", "vendor", grmi.TypeInt)
var WorkOrder_MaintType = grmi.NewField("MaintType", "MaintType", "mainttype", grmi.TypeString)
var WorkOrder_CostCenterId = grmi.NewField("CostCenterId", "CostCenterId", "costcenterid", grmi.TypeString)
var WorkOrder_PoId = grmi.NewField("PoId", "PoId", "poid", grmi.TypeString)
var WorkOrder_LastModify = grmi.NewField("LastModify", "LastModify", "lastmodify", grmi.TypeDateTime)
var WorkOrder_LastUser = grmi.NewField("LastUser", "LastUser", "lastuser", grmi.TypeString)
var WorkOrder_CreateTime = grmi.NewField("CreateTime", "CreateTime", "createtime", grmi.TypeDateTime)

/******************************************************************************
 *
 * @Description              : WorkOrder的元数据
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-04-13 11:00:13
 *
 ******************************************************************************/
var WorkOrder = grmi.NewEntity(
	"PM_WorkOrder",
	func() interface{} { return &model.WorkOrder{} },
	map[string]grmi.Field{
		WorkOrder_MaintWorkOrderId.Name: WorkOrder_MaintWorkOrderId,
		WorkOrder_MainServiceNr.Name:    WorkOrder_MainServiceNr,
		WorkOrder_Descr.Name:            WorkOrder_Descr,
		WorkOrder_Status.Name:           WorkOrder_Status,
		WorkOrder_Priority.Name:         WorkOrder_Priority,
		WorkOrder_AssetNr.Name:          WorkOrder_AssetNr,
		WorkOrder_PlBegDat.Name:         WorkOrder_PlBegDat,
		WorkOrder_PlEndDat.Name:         WorkOrder_PlEndDat,
		WorkOrder_NeedSchedule.Name:     WorkOrder_NeedSchedule,
		WorkOrder_MainTimeLen.Name:      WorkOrder_MainTimeLen,
		WorkOrder_TimeUnit.Name:         WorkOrder_TimeUnit,
		WorkOrder_SchedBegTime.Name:     WorkOrder_SchedBegTime,
		WorkOrder_SchedEndTime.Name:     WorkOrder_SchedEndTime,
		WorkOrder_ActBegTime.Name:       WorkOrder_ActBegTime,
		WorkOrder_ActEndTime.Name:       WorkOrder_ActEndTime,
		WorkOrder_AssignedTo.Name:       WorkOrder_AssignedTo,
		WorkOrder_Operator.Name:         WorkOrder_Operator,
		WorkOrder_Vendor.Name:           WorkOrder_Vendor,
		WorkOrder_MaintType.Name:        WorkOrder_MaintType,
		WorkOrder_CostCenterId.Name:     WorkOrder_CostCenterId,
		WorkOrder_PoId.Name:             WorkOrder_PoId,
		WorkOrder_LastModify.Name:       WorkOrder_LastModify,
		WorkOrder_LastUser.Name:         WorkOrder_LastUser,
		WorkOrder_CreateTime.Name:       WorkOrder_CreateTime,
	},
	[]string{"PlantNr"},
	[]string{WorkOrder_MainServiceNr.ColumnName, WorkOrder_Descr.ColumnName, WorkOrder_Status.ColumnName, WorkOrder_Priority.ColumnName, WorkOrder_AssetNr.ColumnName, WorkOrder_PlBegDat.ColumnName, WorkOrder_PlEndDat.ColumnName, WorkOrder_NeedSchedule.ColumnName, WorkOrder_MainTimeLen.ColumnName, WorkOrder_TimeUnit.ColumnName, WorkOrder_SchedBegTime.ColumnName, WorkOrder_SchedEndTime.ColumnName, WorkOrder_ActBegTime.ColumnName, WorkOrder_ActEndTime.ColumnName, WorkOrder_AssignedTo.ColumnName, WorkOrder_Operator.ColumnName, WorkOrder_Vendor.ColumnName, WorkOrder_MaintType.ColumnName, WorkOrder_CostCenterId.ColumnName, WorkOrder_PoId.ColumnName, WorkOrder_LastUser.ColumnName})
