package log

// 供应商需求明细状态值
const (
	WaitReceivingStatus int = iota // 初始状态
	ReceivedStatus                 // 已接收
	ConfirmedStatus                // 已确认
	AccomplishedStatus             // 已完成
)

/******************************************************************************
 *
 * @Description              : 修改供应商需求明细状态绑定结构体
 *
 * @Author                   : Zhang Xin
 *
 * @Date                     : 2021/3/19
 *
 ******************************************************************************/
type ArtDemandLstStatusChange struct {
	ArtId      string `json:"artId"`
	DemandTime string `json:"demandTime"`
}

/******************************************************************************
 *
 * @Description              : 修改供应商需求明细状态绑定结构体外层切片
 *
 * @Author                   : Zhang Xin
 *
 * @Date                     : 2021/3/19
 *
 ******************************************************************************/
type ArtDemandLstStatusChangeRecords struct {
	Records []ArtDemandLstStatusChange
}

/******************************************************************************
 *
 * @Description              : 通过ArtDemandHead查询ArtDemandLst结构体
 *
 * @Author                   : Zhang Xin
 *
 * @Date                     : 2021/3/23
 *
 ******************************************************************************/
type ArtDemandItem struct {
	ArtId string
	DemandId string
}


/******************************************************************************
 *
 * @Description              : 批量添加VendorArtLst绑定前端结构体
 *
 * @Author                   : Zhang Xin
 *
 * @Date                     : 2021/3/25
 *
 ******************************************************************************/
type VendorArtLstInsert struct {
	VendorId string `json:"vendorId"`
	Records []VendorArtLst `json:"records"`
}

/******************************************************************************
 *
 * @Description              : 批量添加VendorUserLst绑定前端结构体
 *
 * @Author                   : Zhang Xin
 *
 * @Date                     : 2021/3/25
 *
 ******************************************************************************/
type VendorUserLstInsert struct {
	VendorId string `json:"vendorId"`
	Records []VendorUserLst `json:"records"`
}