// Copyright (c) Shenyang Leading Edge Intelligent Technology Co., Ltd. All rights reserved.

package implments

import (
	"LAPP_GAAS_GFrame_BACKEND/dao/base"
	dal "LAPP_GAAS_GFrame_BACKEND/dao/log"
	"LAPP_GAAS_GFrame_BACKEND/db"
	"LAPP_GAAS_GFrame_BACKEND/grmi"
	meta "LAPP_GAAS_GFrame_BACKEND/meta/log"
	model "LAPP_GAAS_GFrame_BACKEND/models/log"
	"LAPP_GAAS_GFrame_BACKEND/web/models"
	"github.com/go-xorm/xorm"
	"time"
)

/******************************************************************************
 *
 * @Description              : PackOrder的默认查询条件
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-03-23 10:43:27
 *
 ******************************************************************************/
var DefaultConditionOfPackOrder = grmi.NewCondition(
	map[string]grmi.ConditionItem{
		meta.PackOrder_PackOrderId.UrlParameterName:     grmi.NewConditionItem(meta.PackOrder_PackOrderId, grmi.Equal, true),
		meta.PackOrder_OrderInfo.UrlParameterName:       grmi.NewConditionItem(meta.PackOrder_OrderInfo, grmi.Equal, false),
		meta.PackOrder_PackTemplateId.UrlParameterName:  grmi.NewConditionItem(meta.PackOrder_PackTemplateId, grmi.Equal, false),
		meta.PackOrder_PackTypeId.UrlParameterName:      grmi.NewConditionItem(meta.PackOrder_PackTypeId, grmi.Equal, false),
		meta.PackOrder_TerminalId.UrlParameterName:      grmi.NewConditionItem(meta.PackOrder_TerminalId, grmi.Equal, false),
		meta.PackOrder_WorkplaceId.UrlParameterName:     grmi.NewConditionItem(meta.PackOrder_WorkplaceId, grmi.Equal, false),
		meta.PackOrder_PersonNr.UrlParameterName:        grmi.NewConditionItem(meta.PackOrder_PersonNr, grmi.Equal, false),
		meta.PackOrder_ShiftId.UrlParameterName:         grmi.NewConditionItem(meta.PackOrder_ShiftId, grmi.Equal, false),
		meta.PackOrder_MaterialId.UrlParameterName:      grmi.NewConditionItem(meta.PackOrder_MaterialId, grmi.Equal, false),
		meta.PackOrder_Status.UrlParameterName:          grmi.NewConditionItem(meta.PackOrder_Status, grmi.Equal, false),
		meta.PackOrder_ShortPack.UrlParameterName:       grmi.NewConditionItem(meta.PackOrder_ShortPack, grmi.Equal, false),
		meta.PackOrder_ShortBy.UrlParameterName:         grmi.NewConditionItem(meta.PackOrder_ShortBy, grmi.Equal, false),
		meta.PackOrder_ShortTime.UrlParameterName:       grmi.NewConditionItem(meta.PackOrder_ShortTime, grmi.Approximate, false),
		meta.PackOrder_ShipStatus.UrlParameterName:      grmi.NewConditionItem(meta.PackOrder_ShipStatus, grmi.Equal, false),
		meta.PackOrder_PlanQty.UrlParameterName:         grmi.NewConditionItem(meta.PackOrder_PlanQty, grmi.Equal, false),
		meta.PackOrder_ActQty.UrlParameterName:          grmi.NewConditionItem(meta.PackOrder_ActQty, grmi.Equal, false),
		meta.PackOrder_OpenTime.UrlParameterName:        grmi.NewConditionItem(meta.PackOrder_OpenTime, grmi.Approximate, false),
		meta.PackOrder_CloseTime.UrlParameterName:       grmi.NewConditionItem(meta.PackOrder_CloseTime, grmi.Approximate, false),
		meta.PackOrder_BackFlushStatus.UrlParameterName: grmi.NewConditionItem(meta.PackOrder_BackFlushStatus, grmi.Equal, false),
		meta.PackOrder_BackFlushTime.UrlParameterName:   grmi.NewConditionItem(meta.PackOrder_BackFlushTime, grmi.Approximate, false),
		meta.PackOrder_BoxSid.UrlParameterName:          grmi.NewConditionItem(meta.PackOrder_BoxSid, grmi.Equal, false),
		meta.PackOrder_SyncSid.UrlParameterName:         grmi.NewConditionItem(meta.PackOrder_SyncSid, grmi.Equal, false),
		meta.PackOrder_PKOCustC1.UrlParameterName:       grmi.NewConditionItem(meta.PackOrder_PKOCustC1, grmi.Equal, false),
		meta.PackOrder_PKOCustC2.UrlParameterName:       grmi.NewConditionItem(meta.PackOrder_PKOCustC2, grmi.Equal, false),
		meta.PackOrder_PKOCustI1.UrlParameterName:       grmi.NewConditionItem(meta.PackOrder_PKOCustI1, grmi.Equal, false),
		meta.PackOrder_PKOCustI2.UrlParameterName:       grmi.NewConditionItem(meta.PackOrder_PKOCustI2, grmi.Equal, false),
		meta.PackOrder_LastModify.UrlParameterName:      grmi.NewConditionItem(meta.PackOrder_LastModify, grmi.Approximate, false),
		meta.PackOrder_LastUser.UrlParameterName:        grmi.NewConditionItem(meta.PackOrder_LastUser, grmi.Equal, false),
		meta.PackOrder_CreateTime.UrlParameterName:      grmi.NewConditionItem(meta.PackOrder_CreateTime, grmi.Approximate, false),
	},
	nil,
)

/******************************************************************************
 *
 * @Description              : PackOrder的默认分页查询条件
 *
 * @Author                   : chenglei.wei@le-it.com.cn
 *
 * @Date                     : 2021-03-23 10:43:27
 *
 ******************************************************************************/
var DefaultConditionOfPackOrderAndPaging = grmi.NewCondition(
	DefaultConditionOfPackOrder.Items,
	grmi.NewPaging(),
)

/******************************************************************************
 *
 * @Description              : 查询Article对应包装模板
 *
 * @Author                   : chenglei.wei@le-it.com.cn
 *
 * @Date                     : 2021-03-23
 *
 ******************************************************************************/
var ConditionOfPackTemplatesOfArticle = grmi.NewCondition(
	map[string]grmi.ConditionItem{},
	nil,
)

/******************************************************************************
 *
 * @Description              : 查询包装单所属包装项
 *
 * @Author                   : chenglei.wei@le-it.com.cn
 *
 * @Date                     : 2021-03-23
 *
 ******************************************************************************/
var ConditionOfItemsOfPackOrder = grmi.NewCondition(
	map[string]grmi.ConditionItem{
		meta.PackOrderItemlst_PackOrderId.UrlParameterName: grmi.NewConditionItem(meta.PackOrderItemlst_PackOrderId, grmi.Equal, true),
	},
	nil,
)

/******************************************************************************
 *
 * @Description              : 查询包装单模板所属包装项模板
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-03-23
 *
 ******************************************************************************/
var ConditionOfItemsOfPackOrderTemplate = grmi.NewCondition(
	map[string]grmi.ConditionItem{
		meta.PackTemplateItemlst_PackTemplateId.UrlParameterName: grmi.NewConditionItem(meta.PackTemplateItemlst_PackTemplateId, grmi.Equal, true),
	},
	nil,
)

/******************************************************************************
*
* @Struct Name              : PackOrderServiceImplement
*-----------------------------------------------------------------------------
*
* @Description              : PackOrder的服务实现
*
* @Author                   : 代码生成器创建
*
* @Date                     : 2021-03-23 10:43:27
*
******************************************************************************/
type PackOrderServiceImplement struct {
}

/******************************************************************************
 *
 * @Function Name            : NewPackOrderDAOImplement
 *-----------------------------------------------------------------------------
 *
 * @Description              : 创建一个PackOrderDAOImplement实例
 *
 * @Return Value             : PackOrderDAOImplement实例
 *
 * @Author                   : 代码生成器创建
 *
 * @Date                     : 2021-03-23 10:43:27
 *
 ******************************************************************************/
func NewPackOrderServiceImplement() *PackOrderServiceImplement {
	return &PackOrderServiceImplement{}
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/log/PackOrderService.InsertOne
 *
 ******************************************************************************/
func (impl *PackOrderServiceImplement) InsertOne(user *models.Usertab, entity *model.PackOrder) error {

	grmi.Log(user, "/services/log/implments/LOG_PackOrder.service.impl.go", "InsertOnePackOrder", "插入一个PackOrder")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewPackOrderDAO(session, user.Pid, user.Userid)
	record, err := dao.SelectOne(entity.PackOrderId)
	if err != nil {
		return err
	}
	if record != nil {
		return grmi.NewBusinessError("已经存在相同主键的记录!")
	}
	err = dao.InsertOne(entity)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/log/PackOrderService.DeleteOne
 *
 ******************************************************************************/
func (impl *PackOrderServiceImplement) DeleteOne(user *models.Usertab, packOrderId string) error {

	grmi.Log(user, "/services/log/implments/LOG_PackOrder.service.impl.go", "DeleteOnePackOrder", "删除一个PackOrder")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewPackOrderDAO(session, user.Pid, user.Userid)
	record, err := dao.SelectOne(packOrderId)
	if err != nil {
		return err
	}
	if record == nil {
		return grmi.NewBusinessError("不存在指定记录!")
	}
	err = dao.DeleteOne(packOrderId)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/log/PackOrderService.SelectOne
 *
 ******************************************************************************/
func (impl *PackOrderServiceImplement) SelectOne(user *models.Usertab, packOrderId string) (*model.PackOrder, error) {

	grmi.Log(user, "/services/log/implments/LOG_PackOrder.service.impl.go", "SelectOnePackOrder", "查询一个PackOrder")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewPackOrderDAO(session, user.Pid, user.Userid)
	result, err := dao.SelectOne(packOrderId)
	if err != nil {
		return nil, err
	}
	return result, nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/log/PackOrderService.UpdateOne
 *
 ******************************************************************************/
func (impl *PackOrderServiceImplement) UpdateOne(user *models.Usertab, entity *model.PackOrder) error {

	grmi.Log(user, "/services/log/implments/LOG_PackOrder.service.impl.go", "UpdateOnePackOrder", "修改一个PackOrder")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewPackOrderDAO(session, user.Pid, user.Userid)
	record, err := dao.SelectOne(entity.PackOrderId)
	if err != nil {
		return err
	}
	if record == nil {
		return grmi.NewBusinessError("不存在指定记录!")
	}
	err = dao.UpdateOne(entity)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/log/PackOrderService.Insert
 *
 ******************************************************************************/
func (impl *PackOrderServiceImplement) Insert(user *models.Usertab, entities *[]model.PackOrder) error {

	grmi.Log(user, "/services/log/implments/LOG_PackOrder.service.impl.go", "InsertPackOrder", "插入多个PackOrder")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewPackOrderDAO(session, user.Pid, user.Userid)

	for _, entity := range *entities {
		record, err := dao.SelectOne(entity.PackOrderId)
		if err != nil {
			return err
		}
		if record != nil {
			return grmi.NewBusinessError("已经存在相同主键的记录!")
		}
	}

	err := dao.Insert(entities)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/log/PackOrderService.Delete
 *
 ******************************************************************************/
func (impl *PackOrderServiceImplement) Delete(user *models.Usertab, entities *[]model.PackOrder) error {

	grmi.Log(user, "/services/log/implments/LOG_PackOrder.service.impl.go", "DeletePackOrder", "删除多个PackOrder")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewPackOrderDAO(session, user.Pid, user.Userid)

	for _, entity := range *entities {
		record, err := dao.SelectOne(entity.PackOrderId)
		if err != nil {
			return err
		}
		if record == nil {
			return grmi.NewBusinessError("不存在指定记录!")
		}
	}

	err := dao.Delete(entities)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/log/PackOrderService.Select
 *
 ******************************************************************************/
func (impl *PackOrderServiceImplement) Select(user *models.Usertab, urlParameters map[string]string) (interface{}, error) {

	grmi.Log(user, "/services/log/implments/LOG_PackOrder.service.impl.go", "SelectPackOrder", "查询PackOrder")

	condition := DefaultConditionOfPackOrderAndPaging
	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	predicates, err := condition.BuildPredicates(urlParameters)
	if err != nil {
		return nil, err
	}
	dao := dal.NewPackOrderDAO(session, user.Pid, user.Userid)
	if condition.Fill(urlParameters) {
		result, err := dao.SelectAndPaging(condition.Paging, predicates, condition.OrderByFields)
		if err != nil {
			return nil, err
		}
		return result, nil
	} else {
		result, err := dao.Select(predicates, condition.OrderByFields)
		if err != nil {
			return nil, err
		}
		return result, nil
	}
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/log/PackOrderService.Update
 *
 ******************************************************************************/
func (impl *PackOrderServiceImplement) Update(user *models.Usertab, entities *[]model.PackOrder) error {

	grmi.Log(user, "/services/log/implments/LOG_PackOrder.service.impl.go", "UpdatePackOrder", "修改多个PackOrder")

	engine := db.Eloquent.Master()
	session := engine.NewSession()
	defer session.Close()
	dao := dal.NewPackOrderDAO(session, user.Pid, user.Userid)

	for _, entity := range *entities {
		record, err := dao.SelectOne(entity.PackOrderId)
		if err != nil {
			return err
		}
		if record == nil {
			return grmi.NewBusinessError("不存在指定记录!")
		}
	}

	err := dao.Update(entities)
	if err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/log/PackOrderService.ClosePackOrder
 *
 ******************************************************************************/
func (self *PackOrderServiceImplement) ClosePackOrder(user *models.Usertab, packOrderId string, poses []int) error {

	if _, err := db.Eloquent.Master().Transaction(func(session *xorm.Session) (interface{}, error) {

		packOrderDAO := dal.NewPackOrderDAO(session, user.Pid, user.Userid)
		order, err := packOrderDAO.SelectOne(packOrderId)
		if err != nil {
			return nil, err
		}
		if order == nil {
			return nil, grmi.NewBusinessError("不存在指定记录!")
		}
		if order.Status != 26 {
			return nil, grmi.NewBusinessError("包装单尚未激活!")
		}
		order.Status = 80
		packOrderItemlstDAO := dal.NewPackOrderItemlstDAO(session, user.Pid, user.Userid)
		predicates, err := ConditionOfItemsOfPackOrder.BuildPredicates(map[string]string{
			meta.PackOrderItemlst_PackOrderId.UrlParameterName: order.PackOrderId,
		})
		if err != nil {
			return nil, err
		}
		closedItems := make([]model.PackOrderItemlst, 0, 10)
		items, err := packOrderItemlstDAO.Select(predicates, ConditionOfPackTemplatesOfArticle.OrderByFields)
		if err != nil {
			return nil, err
		}
		if poses == nil || len(poses) <= 0 {
			for _, item := range items {
				closedItems = append(closedItems, item)
			}
		} else {
			posMapping := make(map[int]int, len(poses))
			for _, pos := range poses {
				posMapping[pos] = pos
			}
			for _, item := range items {
				if _, ok := posMapping[item.Pos]; ok {
					closedItems = append(closedItems, item)
				}
			}
		}
		for i := 0; i < len(closedItems); i++ {
			closedItems[i].Status = 80
		}
		err = packOrderDAO.UpdateOne(order)
		if err != nil {
			return nil, err
		}
		for i := 0; i < len(closedItems); i++ {
			err = packOrderItemlstDAO.UpdateOne(&closedItems[i])
			if err != nil {
				return nil, err
			}
		}
		return nil, nil
	}); err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/log/PackOrderService.OpenPackOrder
 *
 ******************************************************************************/
func (self *PackOrderServiceImplement) OpenPackOrder(user *models.Usertab, artId string) ([]model.PackTemplate, error) {

	if result, err := db.Eloquent.Master().Transaction(func(session *xorm.Session) (interface{}, error) {

		articleDAO := base.NewArticleDAO(session, user.Pid, user.Userid)
		article, err := articleDAO.SelectOne(artId)
		if err != nil {
			return nil, err
		}
		if article == nil {
			return nil, grmi.NewBusinessError("没有在数据库中找到扫码内容对应的信息!")
		}
		packTemplateDAO := dal.NewPackTemplateDAO(session, user.Pid, user.Userid)
		predicates, err := ConditionOfItemsOfPackOrderTemplate.BuildPredicates(map[string]string{})
		if err != nil {
			return nil, err
		}
		packTemplates, err := packTemplateDAO.Select(predicates, ConditionOfPackTemplatesOfArticle.OrderByFields)
		if err != nil {
			return nil, err
		}
		if len(packTemplates) > 1 {
			return packTemplates, nil
		}
		if len(packTemplates) > 0 {
			err = self.CreatePackOrderWithTemplate(session, user, &packTemplates[0])
			if err != nil {
				return nil, err
			}
			return packTemplates, nil
		} else {
			return nil, grmi.NewBusinessError("没找到关联的包装单模板!")
		}
	}); err != nil {
		return nil, err
	} else {
		templates, ok := result.([]model.PackTemplate)
		if !ok {
			return nil, grmi.NewBusinessError("意外的返回结果!")
		}
		return templates, nil
	}
}

/******************************************************************************
 *
 * @Reference LAPP_GAAS_GFrame_BACKEND/services/log/PackOrderService.OpenPackOrderWithTemplate
 *
 ******************************************************************************/
func (self *PackOrderServiceImplement) OpenPackOrderWithTemplate(user *models.Usertab, artId string, packTemplateId string) error {

	if _, err := db.Eloquent.Master().Transaction(func(session *xorm.Session) (interface{}, error) {

		articleDAO := base.NewArticleDAO(session, user.Pid, user.Userid)
		article, err := articleDAO.SelectOne(artId)
		if err != nil {
			return nil, err
		}
		if article == nil {
			return nil, grmi.NewBusinessError("没有在数据库中找到扫码内容对应的信息!")
		}
		packTemplateDAO := dal.NewPackTemplateDAO(session, user.Pid, user.Userid)
		packTemplate, err := packTemplateDAO.SelectOne(packTemplateId)
		if err != nil {
			return nil, err
		}
		if packTemplate == nil {
			return nil, grmi.NewBusinessError("不存在指定包装单模板!")
		}
		err = self.CreatePackOrderWithTemplate(session, user, packTemplate)
		if err != nil {
			return nil, err
		}
		return nil, nil
	}); err != nil {
		return err
	}
	return nil
}

/******************************************************************************
 *
 * @Function Name            : OpenPackOrder
 *-----------------------------------------------------------------------------
 *
 * @Description              : 根据Article标识创建包装单
 *
 * @Function Parameters      : 当前访问人员信息
 *
 * @Function Parameters      : Article标识
 *
 * @Return Value             : 包装单模板,当只有一项返回时,根据返回的模板创建包装单,不会为空,如果未找到模板直接报错.
 *
 * @Return Value             : 执行时发生的错误
 *
 * @Author                   : chenglei.wei@le-it.com.cn
 *
 * @Date                     : 2021-03-18
 *
 ******************************************************************************/
func (self *PackOrderServiceImplement) CreatePackOrderWithTemplate(session *xorm.Session, user *models.Usertab, packTemplate *model.PackTemplate) error {

	packTemplateItemlstDAO := dal.NewPackTemplateItemlstDAO(session, user.Pid, user.Userid)
	predicates, err := ConditionOfItemsOfPackOrderTemplate.BuildPredicates(map[string]string{
		meta.PackTemplateItemlst_PackTemplateId.UrlParameterName: packTemplate.PackTemplateId,
	})
	if err != nil {
		return err
	}
	packTemplateItems, err := packTemplateItemlstDAO.Select(predicates, ConditionOfPackTemplatesOfArticle.OrderByFields)
	if err != nil {
		return err
	}
	packOrderId := "PACK" + time.Now().Format("20060102150405")
	packOrderDAO := dal.NewPackOrderDAO(session, user.Pid, user.Userid)
	err = packOrderDAO.InsertOne(&model.PackOrder{
		PlantNr:        packTemplate.PlantNr,
		PackOrderId:    packOrderId,
		Status:         26,
		PackTemplateId: packTemplate.PackTemplateId,
		PackTypeId:     packTemplate.PackTypeId,
		MaterialId:     packTemplate.MaterialId,
		PlanQty:        float64(packTemplate.PlanQty),
	})
	if err != nil {
		return err
	}
	items := make([]*model.PackOrderItemlst, 0, 10)
	for _, packTemplateItem := range packTemplateItems {
		items = append(items, &model.PackOrderItemlst{
			PlantNr:     packTemplateItem.PlantNr,
			PackOrderId: packOrderId,
			Pos:         packTemplateItem.Pos,
			PosCode:     packTemplateItem.PosCode,
			MaterialId:  packTemplateItem.MaterialId,
			PlanQty:     float64(packTemplateItem.PlanQty),
			ActQty:      1,
			Status:      26,
			Seq:         packTemplateItem.Seq,
		})
	}
	packOrderItemlstDAO := dal.NewPackOrderItemlstDAO(session, user.Pid, user.Userid)
	for _, item := range items {
		err = packOrderItemlstDAO.InsertOne(item)
		if err != nil {
			return err
		}
	}
	return nil
}
